#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

class StringReplacement
{
private:
   string strSearchText;
   string strReplaceText;

public:
   StringReplacement(void)
   {
   }
   StringReplacement( string search, string replace )
   {
      strSearchText = search;
      strReplaceText = replace;
   }
   void DoReplace( string& text )
   {
      int i=0;
      string strComplete = "";
      while ( i < text.size() )
      {
         if ( !strncmp(text.c_str()+i, strSearchText.c_str(), strSearchText.size()) )
         {
            i += strSearchText.size();
            strComplete += strReplaceText;
         }
         else
         {
            strComplete += text[i];
            i++;
         }
      }
      text = strComplete;
   }
};


vector< StringReplacement, allocator<StringReplacement> > strList;

int main(int argc, char **argv)
{
   if ( argc < 2 )
   {
      printf(": repl <input-file> <definitions-file>\n");
      return -1;
   }

   FILE *fp = fopen(argv[1], "r");
   if ( fp == NULL )
   {
      printf("    %s\n", argv[1] );
      return -1;
   }
   strList.insert( strList.end(), StringReplacement("$$$$", "Matt Telles") );
   strList.insert( strList.end(), StringReplacement("$$$$", "Matt's Test") );

   char szBuffer[ 256 ];
   while ( !feof(fp) )
   {
      if ( fgets(szBuffer, 255, fp) == NULL )
         break;
      string s = szBuffer;

      for ( int i=0; i<strList.size(); ++i )
         strList[i].DoReplace( s );
      printf("%s", s.c_str());

   }

   fclose(fp);
   return 0;
}
